package closestpoints;

import java.io.File;
import java.util.Scanner;

public class ClosestPoints {

    /**
     * Read 1000 points from points.txt. 
     */
    public static Point[] readPoints() {
        Point A[] = new Point[1000];
        Scanner input = null;
        try {
            input = new Scanner(new File("points.txt"));
        } catch (Exception ex) {
            System.out.println("Could not open file.");
            System.exit(1);
        }

        for (int p = 0; p < 1000; p++) {
            double x = input.nextDouble();
            double y = input.nextDouble();
            A[p] = new Point(x,y);
        }

        return A;
    }

    /**
     * Compute the distance between two points (x1, y1) and (x2, y2)
     */
    public static double distance(Point one,Point two) {
        return Math.sqrt((two.x - one.x) * (two.x - one.x) + (two.y - one.y) * (two.y - one.y));
    }

    public static void main(String[] args) {
        Point points[] = readPoints();

        // p1 and p2 are the indices in the points array
        int p1 = 0, p2 = 1; // Initial two points
        double shortestDistance = distance(points[p1],points[p2]); // Initialize shortestDistance

        // Compute distance for every two points
        for (int i = 0; i < points.length; i++) {
            for (int j = i + 1; j < points.length; j++) {
                double distance = distance(points[i],points[j]); // Find distance

                if (shortestDistance > distance) {
                    p1 = i; // Update p1
                    p2 = j; // Update p2
                    shortestDistance = distance; // Update shortestDistance 
                }
            }
        }

        // Display result
        System.out.print("The closest two points are ");
        points[p1].print();
        System.out.print(" and ");
        points[p2].print();
        System.out.println();
    }

}
